{{- range untilStep 1 ( .Values.global.nodeCount | int | add1 | int) 1}}
---
apiVersion: apps/v1
kind: StatefulSet
metadata:
  name: {{ $.Release.Name }}-datanodeset-{{ . }}
  labels:
    node: {{ $.Release.Name }}-datanodeset-{{ . }}

spec:
  selector:
    matchLabels:
      node: {{ $.Release.Name }}-datanode-{{ . }}
  serviceName: {{ $.Release.Name }}-{{ $.Values.global.datanode.serviceName }}-{{ . }}
  replicas: 1
  template:
    metadata:
      labels:
        node: {{ $.Release.Name }}-datanode-{{ . }}

    spec:
      affinity:                                           # this is important for us to create a pod in a node where we have persistent volume of this pod.
        nodeAffinity:
          requiredDuringSchedulingIgnoredDuringExecution:
            nodeSelectorTerms:
              - matchExpressions:
                  - key: node
                    operator: In
                    values:
                    - node{{ . }}

      initContainers:
        - name: delete-last-one
          image: busybox
          command: ["sh", "-c", "rm -rf /opt/hdfs/datanode/in_use.lock"]
          volumeMounts:
            - name: {{ $.Release.Name }}-datanodevol-{{ . }}
              mountPath: /opt/hdfs/datanode
              


      imagePullSecrets:
        - name: {{ $.Values.global.datanode.imagePullSecret}}

      containers:

        - name: {{ $.Release.Name }}-datanode-{{ . }}
          image: {{ $.Values.global.datanode.image}}

          volumeMounts:
            - name: {{ $.Release.Name }}-datanodevol-{{ . }}
              mountPath: /opt/hdfs/datanode
            - name: hadoop-config
              mountPath: /hadoop-3.3.3/etc/hadoop
            
            - name: hadoop-config
              mountPath: /hadoop-3.3.3/etc/hadoop-httpfs/conf

      volumes:
        - name: hadoop-config
          configMap:
            name: {{ $.Release.Name }}-hadoop

  volumeClaimTemplates:
    - metadata:
        name: {{ $.Release.Name }}-datanodevol-{{ . }}
          
      spec: 
        accessModes:
          - ReadWriteOnce

        storageClassName: {{ $.Values.global.datanode.storageClass }}
        resources:
          requests:
            storage: {{ $.Values.global.datanode.storage }}

{{- end}}

          
